SM0 She11
Path:
/
/
usr
/
bin
Full Path (server): /usr/bin
Create Fil3
Upl04d Fil3
📄 7z
[E]
[D]
[R]
📄 7za
[E]
[D]
[R]
📄 GET
[E]
[D]
[R]
📄 HEAD
[E]
[D]
[R]
📄 Magick-config
[E]
[D]
[R]
📄 MagickCore-config
[E]
[D]
[R]
📄 MagickWand-config
[E]
[D]
[R]
📄 POST
[E]
[D]
[R]
📄 Wand-config
[E]
[D]
[R]
📄 [
[E]
[D]
[R]
📄 a2p
[E]
[D]
[R]
📄 ab
[E]
[D]
[R]
📄 aclocal
[E]
[D]
[R]
📄 aclocal-1.13
[E]
[D]
[R]
📄 addr2line
[E]
[D]
[R]
📄 agentxtrap
[E]
[D]
[R]
📄 alias
[E]
[D]
[R]
📄 altermime
[E]
[D]
[R]
📄 amavisd-agent
[E]
[D]
[R]
📄 amavisd-nanny
[E]
[D]
[R]
📄 amavisd-release
[E]
[D]
[R]
📄 amavisd-signer
[E]
[D]
[R]
📄 amavisd-submit
[E]
[D]
[R]
📄 animate
[E]
[D]
[R]
📄 apr-1-config
[E]
[D]
[R]
📄 apropos
[E]
[D]
[R]
📄 apu-1-config
[E]
[D]
[R]
📄 ar
[E]
[D]
[R]
📄 arch
[E]
[D]
[R]
📄 aria_chk
[E]
[D]
[R]
📄 aria_dump_log
[E]
[D]
[R]
📄 aria_ftdump
[E]
[D]
[R]
📄 aria_pack
[E]
[D]
[R]
📄 aria_read_log
[E]
[D]
[R]
📄 arj
[E]
[D]
[R]
📄 arjdisp
[E]
[D]
[R]
📄 arpaname
[E]
[D]
[R]
📄 as
[E]
[D]
[R]
📄 aspell
[E]
[D]
[R]
📄 at
[E]
[D]
[R]
📄 atq
[E]
[D]
[R]
📄 atrm
[E]
[D]
[R]
📄 audit2allow
[E]
[D]
[R]
📄 audit2why
[E]
[D]
[R]
📄 aulast
[E]
[D]
[R]
📄 aulastlog
[E]
[D]
[R]
📄 ausyscall
[E]
[D]
[R]
📄 autoconf
[E]
[D]
[R]
📄 autoheader
[E]
[D]
[R]
📄 autom4te
[E]
[D]
[R]
📄 automake
[E]
[D]
[R]
📄 automake-1.13
[E]
[D]
[R]
📄 autoreconf
[E]
[D]
[R]
📄 autoscan
[E]
[D]
[R]
📄 autoupdate
[E]
[D]
[R]
📄 auvirt
[E]
[D]
[R]
📄 awk
[E]
[D]
[R]
📄 base64
[E]
[D]
[R]
📄 basename
[E]
[D]
[R]
📄 bash
[E]
[D]
[R]
📄 bashbug
[E]
[D]
[R]
📄 bashbug-64
[E]
[D]
[R]
📄 batch
[E]
[D]
[R]
📄 bc
[E]
[D]
[R]
📄 bdftopcf
[E]
[D]
[R]
📄 bdftruncate
[E]
[D]
[R]
📄 bg
[E]
[D]
[R]
📄 bison
[E]
[D]
[R]
📄 bond2team
[E]
[D]
[R]
📄 bootctl
[E]
[D]
[R]
📄 bunzip2
[E]
[D]
[R]
📄 busctl
[E]
[D]
[R]
📄 bzcat
[E]
[D]
[R]
📄 bzcmp
[E]
[D]
[R]
📄 bzdiff
[E]
[D]
[R]
📄 bzgrep
[E]
[D]
[R]
📄 bzip2
[E]
[D]
[R]
📄 bzip2recover
[E]
[D]
[R]
📄 bzless
[E]
[D]
[R]
📄 bzmore
[E]
[D]
[R]
📄 c++
[E]
[D]
[R]
📄 c++filt
[E]
[D]
[R]
📄 c2ph
[E]
[D]
[R]
📄 c89
[E]
[D]
[R]
📄 c99
[E]
[D]
[R]
📄 ca-legacy
[E]
[D]
[R]
📄 cabextract
[E]
[D]
[R]
📄 cairo-sphinx
[E]
[D]
[R]
📄 cal
[E]
[D]
[R]
📄 captoinfo
[E]
[D]
[R]
📄 cat
[E]
[D]
[R]
📄 catchsegv
[E]
[D]
[R]
📄 catman
[E]
[D]
[R]
📄 cc
[E]
[D]
[R]
📄 ccmake
[E]
[D]
[R]
📄 ccmake3
[E]
[D]
[R]
📄 cd
[E]
[D]
[R]
📄 centrino-decode
[E]
[D]
[R]
📄 certutil
[E]
[D]
[R]
📄 certwatch
[E]
[D]
[R]
📄 chacl
[E]
[D]
[R]
📄 chage
[E]
[D]
[R]
📄 chardetect
[E]
[D]
[R]
📄 chattr
[E]
[D]
[R]
📄 chcat
[E]
[D]
[R]
📄 chcon
[E]
[D]
[R]
📄 checkmodule
[E]
[D]
[R]
📄 checkpolicy
[E]
[D]
[R]
📄 chfn
[E]
[D]
[R]
📄 chgrp
[E]
[D]
[R]
📄 chmem
[E]
[D]
[R]
📄 chmod
[E]
[D]
[R]
📄 chown
[E]
[D]
[R]
📄 chronyc
[E]
[D]
[R]
📄 chrt
[E]
[D]
[R]
📄 chsh
[E]
[D]
[R]
📄 chvt
[E]
[D]
[R]
📄 cifsiostat
[E]
[D]
[R]
📄 cksum
[E]
[D]
[R]
📄 clambc
[E]
[D]
[R]
📄 clamconf
[E]
[D]
[R]
📄 clamdscan
[E]
[D]
[R]
📄 clamdtop
[E]
[D]
[R]
📄 clamscan
[E]
[D]
[R]
📄 clamsubmit
[E]
[D]
[R]
📄 clear
[E]
[D]
[R]
📄 cloud-id
[E]
[D]
[R]
📄 cloud-init
[E]
[D]
[R]
📄 cloud-init-per
[E]
[D]
[R]
📄 clusterdb
[E]
[D]
[R]
📄 cmake
[E]
[D]
[R]
📄 cmake3
[E]
[D]
[R]
📄 cmp
[E]
[D]
[R]
📄 cmsutil
[E]
[D]
[R]
📄 col
[E]
[D]
[R]
📄 colcrt
[E]
[D]
[R]
📄 colrm
[E]
[D]
[R]
📄 column
[E]
[D]
[R]
📄 comm
[E]
[D]
[R]
📄 command
[E]
[D]
[R]
📄 compare
[E]
[D]
[R]
📄 compile_et
[E]
[D]
[R]
📄 composite
[E]
[D]
[R]
📄 conjure
[E]
[D]
[R]
📄 consolehelper
[E]
[D]
[R]
📄 convert
[E]
[D]
[R]
📄 coredumpctl
[E]
[D]
[R]
📄 cp
[E]
[D]
[R]
📄 cpack
[E]
[D]
[R]
📄 cpack3
[E]
[D]
[R]
📄 cpio
[E]
[D]
[R]
📄 cpp
[E]
[D]
[R]
📄 cpulimit
[E]
[D]
[R]
📄 cpupower
[E]
[D]
[R]
📄 crc32
[E]
[D]
[R]
📄 createdb
[E]
[D]
[R]
📄 createlang
[E]
[D]
[R]
📄 createuser
[E]
[D]
[R]
📄 crlutil
[E]
[D]
[R]
📄 crontab
[E]
[D]
[R]
📄 csplit
[E]
[D]
[R]
📄 csslint-0.6
[E]
[D]
[R]
📄 ctest
[E]
[D]
[R]
📄 ctest3
[E]
[D]
[R]
📄 curl
[E]
[D]
[R]
📄 curl-config
[E]
[D]
[R]
📄 cut
[E]
[D]
[R]
📄 cvtsudoers
[E]
[D]
[R]
📄 cxpm
[E]
[D]
[R]
📄 date
[E]
[D]
[R]
📄 db_archive
[E]
[D]
[R]
📄 db_checkpoint
[E]
[D]
[R]
📄 db_deadlock
[E]
[D]
[R]
📄 db_dump
[E]
[D]
[R]
📄 db_dump185
[E]
[D]
[R]
📄 db_hotbackup
[E]
[D]
[R]
📄 db_load
[E]
[D]
[R]
📄 db_log_verify
[E]
[D]
[R]
📄 db_printlog
[E]
[D]
[R]
📄 db_recover
[E]
[D]
[R]
📄 db_replicate
[E]
[D]
[R]
📄 db_stat
[E]
[D]
[R]
📄 db_tuner
[E]
[D]
[R]
📄 db_upgrade
[E]
[D]
[R]
📄 db_verify
[E]
[D]
[R]
📄 dbilogstrip
[E]
[D]
[R]
📄 dbinfo
[E]
[D]
[R]
📄 dbiprof
[E]
[D]
[R]
📄 dbiproxy
[E]
[D]
[R]
📄 dbus-binding-tool
[E]
[D]
[R]
📄 dbus-cleanup-sockets
[E]
[D]
[R]
📄 dbus-daemon
[E]
[D]
[R]
📄 dbus-monitor
[E]
[D]
[R]
📄 dbus-run-session
[E]
[D]
[R]
📄 dbus-send
[E]
[D]
[R]
📄 dbus-test-tool
[E]
[D]
[R]
📄 dbus-update-activation-environment
[E]
[D]
[R]
📄 dbus-uuidgen
[E]
[D]
[R]
📄 dc
[E]
[D]
[R]
📄 dd
[E]
[D]
[R]
📄 deallocvt
[E]
[D]
[R]
📄 debuginfo-install
[E]
[D]
[R]
📄 defunct
[E]
[D]
[R]
📄 delv
[E]
[D]
[R]
📄 derb
[E]
[D]
[R]
📄 df
[E]
[D]
[R]
📄 dgawk
[E]
[D]
[R]
📄 diff
[E]
[D]
[R]
📄 diff3
[E]
[D]
[R]
📄 dig
[E]
[D]
[R]
📄 dir
[E]
[D]
[R]
📄 dircolors
[E]
[D]
[R]
📄 dirname
[E]
[D]
[R]
📄 display
[E]
[D]
[R]
📄 dm_date
[E]
[D]
[R]
📄 dm_zdump
[E]
[D]
[R]
📄 dmesg
[E]
[D]
[R]
📄 dnsdomainname
[E]
[D]
[R]
📄 domainname
[E]
[D]
[R]
📄 doveadm
[E]
[D]
[R]
📄 doveconf
[E]
[D]
[R]
📄 dracut
[E]
[D]
[R]
📄 dropdb
[E]
[D]
[R]
📄 droplang
[E]
[D]
[R]
📄 dropuser
[E]
[D]
[R]
📄 dsync
[E]
[D]
[R]
📄 dtrace
[E]
[D]
[R]
📄 du
[E]
[D]
[R]
📄 dumpkeys
[E]
[D]
[R]
📄 dumpsexp
[E]
[D]
[R]
📄 dwp
[E]
[D]
[R]
📄 easy_install
[E]
[D]
[R]
📄 easy_install-2.7
[E]
[D]
[R]
📄 easy_install-3.6
[E]
[D]
[R]
📄 echo
[E]
[D]
[R]
📄 ecpg
[E]
[D]
[R]
📄 ed2k-link
[E]
[D]
[R]
📄 egrep
[E]
[D]
[R]
📄 eject
[E]
[D]
[R]
📄 elfedit
[E]
[D]
[R]
📄 enchant
[E]
[D]
[R]
📄 enchant-lsmod
[E]
[D]
[R]
📄 env
[E]
[D]
[R]
📄 envsubst
[E]
[D]
[R]
📄 eqn
[E]
[D]
[R]
📄 ex
[E]
[D]
[R]
📄 expand
[E]
[D]
[R]
📄 expr
[E]
[D]
[R]
📄 factor
[E]
[D]
[R]
📄 fallocate
[E]
[D]
[R]
📄 false
[E]
[D]
[R]
📄 fc
[E]
[D]
[R]
📄 fc-cache
[E]
[D]
[R]
📄 fc-cache-64
[E]
[D]
[R]
📄 fc-cat
[E]
[D]
[R]
📄 fc-conflist
[E]
[D]
[R]
📄 fc-list
[E]
[D]
[R]
📄 fc-match
[E]
[D]
[R]
📄 fc-pattern
[E]
[D]
[R]
📄 fc-query
[E]
[D]
[R]
📄 fc-scan
[E]
[D]
[R]
📄 fc-validate
[E]
[D]
[R]
📄 fcat
[E]
[D]
[R]
📄 fg
[E]
[D]
[R]
📄 fgconsole
[E]
[D]
[R]
📄 fgrep
[E]
[D]
[R]
📄 file
[E]
[D]
[R]
📄 find
[E]
[D]
[R]
📄 find-repos-of-install
[E]
[D]
[R]
📄 find2perl
[E]
[D]
[R]
📄 findmnt
[E]
[D]
[R]
📄 fipscheck
[E]
[D]
[R]
📄 fipshmac
[E]
[D]
[R]
📄 flex
[E]
[D]
[R]
📄 flex++
[E]
[D]
[R]
📄 flock
[E]
[D]
[R]
📄 fmt
[E]
[D]
[R]
📄 fold
[E]
[D]
[R]
📄 fonttosfnt
[E]
[D]
[R]
📄 formail
[E]
[D]
[R]
📄 free
[E]
[D]
[R]
📄 freetype-config
[E]
[D]
[R]
📄 freeze
[E]
[D]
[R]
📄 freshclam
[E]
[D]
[R]
📄 fribidi
[E]
[D]
[R]
📄 funzip
[E]
[D]
[R]
📄 g++
[E]
[D]
[R]
📄 galera_new_cluster
[E]
[D]
[R]
📄 galera_recovery
[E]
[D]
[R]
📄 gapplication
[E]
[D]
[R]
📄 garb-systemd
[E]
[D]
[R]
📄 garbd
[E]
[D]
[R]
📄 gawk
[E]
[D]
[R]
📄 gcc
[E]
[D]
[R]
📄 gcc-ar
[E]
[D]
[R]
📄 gcc-nm
[E]
[D]
[R]
📄 gcc-ranlib
[E]
[D]
[R]
📄 gcov
[E]
[D]
[R]
📄 gdbus
[E]
[D]
[R]
📄 gdbus-codegen
[E]
[D]
[R]
📄 gdk-pixbuf-query-loaders-64
[E]
[D]
[R]
📄 gdk-pixbuf-thumbnailer
[E]
[D]
[R]
📄 genbrk
[E]
[D]
[R]
📄 gencat
[E]
[D]
[R]
📄 gencfu
[E]
[D]
[R]
📄 gencnval
[E]
[D]
[R]
📄 gendict
[E]
[D]
[R]
📄 genkey
[E]
[D]
[R]
📄 genl-ctrl-list
[E]
[D]
[R]
📄 genrb
[E]
[D]
[R]
📄 geoiplookup
[E]
[D]
[R]
📄 geoiplookup6
[E]
[D]
[R]
📄 geoipupdate
[E]
[D]
[R]
📄 geqn
[E]
[D]
[R]
📄 getconf
[E]
[D]
[R]
📄 getent
[E]
[D]
[R]
📄 getfacl
[E]
[D]
[R]
📄 getkeycodes
[E]
[D]
[R]
📄 getopt
[E]
[D]
[R]
📄 getopts
[E]
[D]
[R]
📄 gettext
[E]
[D]
[R]
📄 gettext.sh
[E]
[D]
[R]
📄 gio
[E]
[D]
[R]
📄 gio-querymodules-64
[E]
[D]
[R]
📄 git
[E]
[D]
[R]
📄 git-receive-pack
[E]
[D]
[R]
📄 git-shell
[E]
[D]
[R]
📄 git-upload-archive
[E]
[D]
[R]
📄 git-upload-pack
[E]
[D]
[R]
📄 glib-compile-resources
[E]
[D]
[R]
📄 glib-compile-schemas
[E]
[D]
[R]
📄 glib-genmarshal
[E]
[D]
[R]
📄 glib-gettextize
[E]
[D]
[R]
📄 glib-mkenums
[E]
[D]
[R]
📄 gmake
[E]
[D]
[R]
📄 gneqn
[E]
[D]
[R]
📄 gnroff
[E]
[D]
[R]
📄 goaccess
[E]
[D]
[R]
📄 gobject-query
[E]
[D]
[R]
📄 gost-hash
[E]
[D]
[R]
📄 gpasswd
[E]
[D]
[R]
📄 gpg
[E]
[D]
[R]
📄 gpg-agent
[E]
[D]
[R]
📄 gpg-connect-agent
[E]
[D]
[R]
📄 gpg-error
[E]
[D]
[R]
📄 gpg-error-config
[E]
[D]
[R]
📄 gpg-zip
[E]
[D]
[R]
📄 gpg2
[E]
[D]
[R]
📄 gpgconf
[E]
[D]
[R]
📄 gpgparsemail
[E]
[D]
[R]
📄 gpgsplit
[E]
[D]
[R]
📄 gpgv
[E]
[D]
[R]
📄 gpgv2
[E]
[D]
[R]
📄 gpic
[E]
[D]
[R]
📄 gprof
[E]
[D]
[R]
📄 gr2fonttest
[E]
[D]
[R]
📄 grep
[E]
[D]
[R]
📄 gresource
[E]
[D]
[R]
📄 groff
[E]
[D]
[R]
📄 grops
[E]
[D]
[R]
📄 grotty
[E]
[D]
[R]
📄 groups
[E]
[D]
[R]
📄 growpart
[E]
[D]
[R]
📄 grub2-editenv
[E]
[D]
[R]
📄 grub2-file
[E]
[D]
[R]
📄 grub2-fstest
[E]
[D]
[R]
📄 grub2-glue-efi
[E]
[D]
[R]
📄 grub2-kbdcomp
[E]
[D]
[R]
📄 grub2-menulst2cfg
[E]
[D]
[R]
📄 grub2-mkfont
[E]
[D]
[R]
📄 grub2-mkimage
[E]
[D]
[R]
📄 grub2-mklayout
[E]
[D]
[R]
📄 grub2-mknetdir
[E]
[D]
[R]
📄 grub2-mkpasswd-pbkdf2
[E]
[D]
[R]
📄 grub2-mkrelpath
[E]
[D]
[R]
📄 grub2-mkrescue
[E]
[D]
[R]
📄 grub2-mkstandalone
[E]
[D]
[R]
📄 grub2-render-label
[E]
[D]
[R]
📄 grub2-script-check
[E]
[D]
[R]
📄 grub2-syslinux2cfg
[E]
[D]
[R]
📄 gsettings
[E]
[D]
[R]
📄 gsoelim
[E]
[D]
[R]
📄 gss-client
[E]
[D]
[R]
📄 gtar
[E]
[D]
[R]
📄 gtbl
[E]
[D]
[R]
📄 gtester
[E]
[D]
[R]
📄 gtester-report
[E]
[D]
[R]
📄 gtroff
[E]
[D]
[R]
📄 gunzip
[E]
[D]
[R]
📄 gzexe
[E]
[D]
[R]
📄 gzip
[E]
[D]
[R]
📄 h2ph
[E]
[D]
[R]
📄 h2xs
[E]
[D]
[R]
📄 has160-hash
[E]
[D]
[R]
📄 head
[E]
[D]
[R]
📄 hexdump
[E]
[D]
[R]
📄 hmac256
[E]
[D]
[R]
📄 host
[E]
[D]
[R]
📄 hostid
[E]
[D]
[R]
📄 hostname
[E]
[D]
[R]
📄 hostnamectl
[E]
[D]
[R]
📄 htdbm
[E]
[D]
[R]
📄 htdigest
[E]
[D]
[R]
📄 htpasswd
[E]
[D]
[R]
📄 httxt2dbm
[E]
[D]
[R]
📄 hunspell
[E]
[D]
[R]
📄 i386
[E]
[D]
[R]
📄 iceauth
[E]
[D]
[R]
📄 iconv
[E]
[D]
[R]
📄 icu-config
[E]
[D]
[R]
📄 icu-config-64
[E]
[D]
[R]
📄 icuinfo
[E]
[D]
[R]
📄 id
[E]
[D]
[R]
📄 identify
[E]
[D]
[R]
📄 idiag-socket-details
[E]
[D]
[R]
📄 idn
[E]
[D]
[R]
📄 ifnames
[E]
[D]
[R]
📄 igawk
[E]
[D]
[R]
📄 imapsync
[E]
[D]
[R]
📄 import
[E]
[D]
[R]
📄 info
[E]
[D]
[R]
📄 infocmp
[E]
[D]
[R]
📄 infokey
[E]
[D]
[R]
📄 infotocap
[E]
[D]
[R]
📄 innochecksum
[E]
[D]
[R]
📄 install
[E]
[D]
[R]
📄 instmodsh
[E]
[D]
[R]
📄 ionice
[E]
[D]
[R]
📄 iostat
[E]
[D]
[R]
📄 ipcalc
[E]
[D]
[R]
📄 ipcmk
[E]
[D]
[R]
📄 ipcrm
[E]
[D]
[R]
📄 ipcs
[E]
[D]
[R]
📄 iptables-xml
[E]
[D]
[R]
📄 isosize
[E]
[D]
[R]
📄 ispell
[E]
[D]
[R]
📄 jemalloc.sh
[E]
[D]
[R]
📄 jobs
[E]
[D]
[R]
📄 join
[E]
[D]
[R]
📄 journalctl
[E]
[D]
[R]
📄 jsonpointer
[E]
[D]
[R]
📄 kbd_mode
[E]
[D]
[R]
📄 kbdinfo
[E]
[D]
[R]
📄 kbdrate
[E]
[D]
[R]
📄 kdumpctl
[E]
[D]
[R]
📄 kernel-install
[E]
[D]
[R]
📄 keyrand
[E]
[D]
[R]
📄 keyutil
[E]
[D]
[R]
📄 kill
[E]
[D]
[R]
📄 killall
[E]
[D]
[R]
📄 kmod
[E]
[D]
[R]
📄 krb5-config
[E]
[D]
[R]
📄 l4p-tmpl
[E]
[D]
[R]
📄 last
[E]
[D]
[R]
📄 lastb
[E]
[D]
[R]
📄 lastlog
[E]
[D]
[R]
📄 lchfn
[E]
[D]
[R]
📄 lchsh
[E]
[D]
[R]
📄 ld
[E]
[D]
[R]
📄 ld.bfd
[E]
[D]
[R]
📄 ld.gold
[E]
[D]
[R]
📄 ldd
[E]
[D]
[R]
📄 less
[E]
[D]
[R]
📄 lessecho
[E]
[D]
[R]
📄 lesskey
[E]
[D]
[R]
📄 lesspipe.sh
[E]
[D]
[R]
📄 lex
[E]
[D]
[R]
📄 lexgrog
[E]
[D]
[R]
📄 libgcrypt-config
[E]
[D]
[R]
📄 libmcrypt-config
[E]
[D]
[R]
📄 libnetcfg
[E]
[D]
[R]
📄 libpng-config
[E]
[D]
[R]
📄 libpng15-config
[E]
[D]
[R]
📄 link
[E]
[D]
[R]
📄 links
[E]
[D]
[R]
📄 links2
[E]
[D]
[R]
📄 linux-boot-prober
[E]
[D]
[R]
📄 linux32
[E]
[D]
[R]
📄 linux64
[E]
[D]
[R]
📄 ln
[E]
[D]
[R]
📄 loadkeys
[E]
[D]
[R]
📄 loadunimap
[E]
[D]
[R]
📄 locale
[E]
[D]
[R]
📄 localectl
[E]
[D]
[R]
📄 localedef
[E]
[D]
[R]
📄 locate
[E]
[D]
[R]
📄 lockfile
[E]
[D]
[R]
📄 logger
[E]
[D]
[R]
📄 login
[E]
[D]
[R]
📄 loginctl
[E]
[D]
[R]
📄 logname
[E]
[D]
[R]
📄 logresolve
[E]
[D]
[R]
📄 look
[E]
[D]
[R]
📄 ls
[E]
[D]
[R]
📄 lsattr
[E]
[D]
[R]
📄 lsblk
[E]
[D]
[R]
📄 lscpu
[E]
[D]
[R]
📄 lsinitrd
[E]
[D]
[R]
📄 lsipc
[E]
[D]
[R]
📄 lslocks
[E]
[D]
[R]
📄 lslogins
[E]
[D]
[R]
📄 lsmem
[E]
[D]
[R]
📄 lsns
[E]
[D]
[R]
📄 lua
[E]
[D]
[R]
📄 luac
[E]
[D]
[R]
📄 lwp-download
[E]
[D]
[R]
📄 lwp-dump
[E]
[D]
[R]
📄 lwp-mirror
[E]
[D]
[R]
📄 lwp-request
[E]
[D]
[R]
📄 lz4
[E]
[D]
[R]
📄 lz4c
[E]
[D]
[R]
📄 lz4cat
[E]
[D]
[R]
📄 lzop
[E]
[D]
[R]
📄 m4
[E]
[D]
[R]
📄 machinectl
[E]
[D]
[R]
📄 magnet-link
[E]
[D]
[R]
📄 mailq
[E]
[D]
[R]
📄 mailq.postfix
[E]
[D]
[R]
📄 mailstat
[E]
[D]
[R]
📄 make
[E]
[D]
[R]
📄 makeconv
[E]
[D]
[R]
📄 makedb
[E]
[D]
[R]
📄 man
[E]
[D]
[R]
📄 mandb
[E]
[D]
[R]
📄 manpath
[E]
[D]
[R]
📄 mapscrn
[E]
[D]
[R]
📄 mariadb-service-convert
[E]
[D]
[R]
📄 mariadb_config
[E]
[D]
[R]
📄 mcookie
[E]
[D]
[R]
📄 md5sum
[E]
[D]
[R]
📄 mdig
[E]
[D]
[R]
📄 melt
[E]
[D]
[R]
📄 mesg
[E]
[D]
[R]
📄 mimedump
[E]
[D]
[R]
📄 mimeencode
[E]
[D]
[R]
📄 mimeexplode
[E]
[D]
[R]
📄 mimepostcard
[E]
[D]
[R]
📄 mimesend
[E]
[D]
[R]
📄 miniterm.py
[E]
[D]
[R]
📄 mkdir
[E]
[D]
[R]
📄 mkfifo
[E]
[D]
[R]
📄 mkfontdir
[E]
[D]
[R]
📄 mkfontscale
[E]
[D]
[R]
📄 mkinitrd
[E]
[D]
[R]
📄 mknod
[E]
[D]
[R]
📄 mktemp
[E]
[D]
[R]
📄 modutil
[E]
[D]
[R]
📄 mogrify
[E]
[D]
[R]
📄 montage
[E]
[D]
[R]
📄 more
[E]
[D]
[R]
📄 mount
[E]
[D]
[R]
📄 mountpoint
[E]
[D]
[R]
📄 mpstat
[E]
[D]
[R]
📄 msgattrib
[E]
[D]
[R]
📄 msgcat
[E]
[D]
[R]
📄 msgcmp
[E]
[D]
[R]
📄 msgcomm
[E]
[D]
[R]
📄 msgconv
[E]
[D]
[R]
📄 msgen
[E]
[D]
[R]
📄 msgexec
[E]
[D]
[R]
📄 msgfilter
[E]
[D]
[R]
📄 msgfmt
[E]
[D]
[R]
📄 msggrep
[E]
[D]
[R]
📄 msghack
[E]
[D]
[R]
📄 msginit
[E]
[D]
[R]
📄 msgmerge
[E]
[D]
[R]
📄 msgunfmt
[E]
[D]
[R]
📄 msguniq
[E]
[D]
[R]
📄 msql2mysql
[E]
[D]
[R]
📄 mv
[E]
[D]
[R]
📄 my_print_defaults
[E]
[D]
[R]
📄 myisam_ftdump
[E]
[D]
[R]
📄 myisamchk
[E]
[D]
[R]
📄 myisamlog
[E]
[D]
[R]
📄 myisampack
[E]
[D]
[R]
📄 mysql
[E]
[D]
[R]
📄 mysql_config
[E]
[D]
[R]
📄 mysql_convert_table_format
[E]
[D]
[R]
📄 mysql_embedded
[E]
[D]
[R]
📄 mysql_find_rows
[E]
[D]
[R]
📄 mysql_fix_extensions
[E]
[D]
[R]
📄 mysql_install_db
[E]
[D]
[R]
📄 mysql_plugin
[E]
[D]
[R]
📄 mysql_secure_installation
[E]
[D]
[R]
📄 mysql_setpermission
[E]
[D]
[R]
📄 mysql_tzinfo_to_sql
[E]
[D]
[R]
📄 mysql_upgrade
[E]
[D]
[R]
📄 mysql_waitpid
[E]
[D]
[R]
📄 mysql_zap
[E]
[D]
[R]
📄 mysqlaccess
[E]
[D]
[R]
📄 mysqladmin
[E]
[D]
[R]
📄 mysqlbinlog
[E]
[D]
[R]
📄 mysqlbug
[E]
[D]
[R]
📄 mysqlcheck
[E]
[D]
[R]
📄 mysqld_multi
[E]
[D]
[R]
📄 mysqld_safe
[E]
[D]
[R]
📄 mysqld_safe_helper
[E]
[D]
[R]
📄 mysqldump
[E]
[D]
[R]
📄 mysqldumpslow
[E]
[D]
[R]
📄 mysqlhotcopy
[E]
[D]
[R]
📄 mysqlimport
[E]
[D]
[R]
📄 mysqlshow
[E]
[D]
[R]
📄 mysqlslap
[E]
[D]
[R]
📄 named-rrchecker
[E]
[D]
[R]
📄 namei
[E]
[D]
[R]
📄 nano
[E]
[D]
[R]
📄 ncurses5-config
[E]
[D]
[R]
📄 ncursesw5-config
[E]
[D]
[R]
📄 ndptool
[E]
[D]
[R]
📄 needs-restarting
[E]
[D]
[R]
📄 neqn
[E]
[D]
[R]
📄 net-server
[E]
[D]
[R]
📄 net-snmp-config
[E]
[D]
[R]
📄 net-snmp-config-x86_64
[E]
[D]
[R]
📄 net-snmp-create-v3-user
[E]
[D]
[R]
📄 netstat
[E]
[D]
[R]
📄 nettle-hash
[E]
[D]
[R]
📄 nettle-lfib-stream
[E]
[D]
[R]
📄 newaliases
[E]
[D]
[R]
📄 newaliases.postfix
[E]
[D]
[R]
📄 newgidmap
[E]
[D]
[R]
📄 newgrp
[E]
[D]
[R]
📄 newuidmap
[E]
[D]
[R]
📄 nf-ct-add
[E]
[D]
[R]
📄 nf-ct-list
[E]
[D]
[R]
📄 nf-exp-add
[E]
[D]
[R]
📄 nf-exp-delete
[E]
[D]
[R]
📄 nf-exp-list
[E]
[D]
[R]
📄 nf-log
[E]
[D]
[R]
📄 nf-monitor
[E]
[D]
[R]
📄 nf-queue
[E]
[D]
[R]
📄 nfsiostat-sysstat
[E]
[D]
[R]
📄 ngettext
[E]
[D]
[R]
📄 nice
[E]
[D]
[R]
📄 nisdomainname
[E]
[D]
[R]
📄 nl
[E]
[D]
[R]
📄 nl-addr-add
[E]
[D]
[R]
📄 nl-addr-delete
[E]
[D]
[R]
📄 nl-addr-list
[E]
[D]
[R]
📄 nl-class-add
[E]
[D]
[R]
📄 nl-class-delete
[E]
[D]
[R]
📄 nl-class-list
[E]
[D]
[R]
📄 nl-classid-lookup
[E]
[D]
[R]
📄 nl-cls-add
[E]
[D]
[R]
📄 nl-cls-delete
[E]
[D]
[R]
📄 nl-cls-list
[E]
[D]
[R]
📄 nl-fib-lookup
[E]
[D]
[R]
📄 nl-link-enslave
[E]
[D]
[R]
📄 nl-link-ifindex2name
[E]
[D]
[R]
📄 nl-link-list
[E]
[D]
[R]
📄 nl-link-name2ifindex
[E]
[D]
[R]
📄 nl-link-release
[E]
[D]
[R]
📄 nl-link-set
[E]
[D]
[R]
📄 nl-link-stats
[E]
[D]
[R]
📄 nl-list-caches
[E]
[D]
[R]
📄 nl-list-sockets
[E]
[D]
[R]
📄 nl-monitor
[E]
[D]
[R]
📄 nl-neigh-add
[E]
[D]
[R]
📄 nl-neigh-delete
[E]
[D]
[R]
📄 nl-neigh-list
[E]
[D]
[R]
📄 nl-neightbl-list
[E]
[D]
[R]
📄 nl-pktloc-lookup
[E]
[D]
[R]
📄 nl-qdisc-add
[E]
[D]
[R]
📄 nl-qdisc-delete
[E]
[D]
[R]
📄 nl-qdisc-list
[E]
[D]
[R]
📄 nl-route-add
[E]
[D]
[R]
📄 nl-route-delete
[E]
[D]
[R]
📄 nl-route-get
[E]
[D]
[R]
📄 nl-route-list
[E]
[D]
[R]
📄 nl-rule-list
[E]
[D]
[R]
📄 nl-tctree-list
[E]
[D]
[R]
📄 nl-util-addr
[E]
[D]
[R]
📄 nm
[E]
[D]
[R]
📄 nohup
[E]
[D]
[R]
📄 nomarch
[E]
[D]
[R]
📄 nproc
[E]
[D]
[R]
📄 nroff
[E]
[D]
[R]
📄 nsenter
[E]
[D]
[R]
📄 nslookup
[E]
[D]
[R]
📄 nss-policy-check
[E]
[D]
[R]
📄 nsupdate
[E]
[D]
[R]
📄 numfmt
[E]
[D]
[R]
📄 objcopy
[E]
[D]
[R]
📄 objdump
[E]
[D]
[R]
📄 od
[E]
[D]
[R]
📄 offlineimap
[E]
[D]
[R]
📄 oldfind
[E]
[D]
[R]
📄 onig-config
[E]
[D]
[R]
📄 opax
[E]
[D]
[R]
📄 open
[E]
[D]
[R]
📄 openssl
[E]
[D]
[R]
📄 openvt
[E]
[D]
[R]
📄 os-prober
[E]
[D]
[R]
📄 p11-kit
[E]
[D]
[R]
📄 package-cleanup
[E]
[D]
[R]
📄 package-stash-conflicts
[E]
[D]
[R]
📄 page_owner_sort
[E]
[D]
[R]
📄 pango-list
[E]
[D]
[R]
📄 pango-querymodules-64
[E]
[D]
[R]
📄 pango-view
[E]
[D]
[R]
📄 paperconf
[E]
[D]
[R]
📄 passwd
[E]
[D]
[R]
📄 paste
[E]
[D]
[R]
📄 pathchk
[E]
[D]
[R]
📄 pax
[E]
[D]
[R]
📄 pchrt
[E]
[D]
[R]
📄 pcre-config
[E]
[D]
[R]
📄 peekfd
[E]
[D]
[R]
📄 perl
[E]
[D]
[R]
📄 perl5.16.3
[E]
[D]
[R]
📄 perlbug
[E]
[D]
[R]
📄 perldoc
[E]
[D]
[R]
📄 perlivp
[E]
[D]
[R]
📄 perlthanks
[E]
[D]
[R]
📄 perror
[E]
[D]
[R]
📄 pflags
[E]
[D]
[R]
📄 pg_config
[E]
[D]
[R]
📄 pg_dump
[E]
[D]
[R]
📄 pg_dumpall
[E]
[D]
[R]
📄 pg_restore
[E]
[D]
[R]
📄 pgawk
[E]
[D]
[R]
📄 pgrep
[E]
[D]
[R]
📄 php
[E]
[D]
[R]
📄 pic
[E]
[D]
[R]
📄 piconv
[E]
[D]
[R]
📄 pidstat
[E]
[D]
[R]
📄 pinentry
[E]
[D]
[R]
📄 pinentry-curses
[E]
[D]
[R]
📄 ping
[E]
[D]
[R]
📄 ping6
[E]
[D]
[R]
📄 pinky
[E]
[D]
[R]
📄 pip-3
[E]
[D]
[R]
📄 pip-3.6
[E]
[D]
[R]
📄 pip3
[E]
[D]
[R]
📄 pip3.6
[E]
[D]
[R]
📄 pk12util
[E]
[D]
[R]
📄 pkaction
[E]
[D]
[R]
📄 pkcheck
[E]
[D]
[R]
📄 pkcs1-conv
[E]
[D]
[R]
📄 pkexec
[E]
[D]
[R]
📄 pkg-config
[E]
[D]
[R]
📄 pkgdata
[E]
[D]
[R]
📄 pkill
[E]
[D]
[R]
📄 pkla-admin-identities
[E]
[D]
[R]
📄 pkla-check-authorization
[E]
[D]
[R]
📄 pkttyagent
[E]
[D]
[R]
📄 pl2pm
[E]
[D]
[R]
📄 pldd
[E]
[D]
[R]
📄 pmap
[E]
[D]
[R]
📄 pod2html
[E]
[D]
[R]
📄 pod2man
[E]
[D]
[R]
📄 pod2text
[E]
[D]
[R]
📄 pod2usage
[E]
[D]
[R]
📄 post-grohtml
[E]
[D]
[R]
📄 powernow-k8-decode
[E]
[D]
[R]
📄 pr
[E]
[D]
[R]
📄 pre-grohtml
[E]
[D]
[R]
📄 precat
[E]
[D]
[R]
📄 preconv
[E]
[D]
[R]
📄 preunzip
[E]
[D]
[R]
📄 prezip
[E]
[D]
[R]
📄 prezip-bin
[E]
[D]
[R]
📄 printenv
[E]
[D]
[R]
📄 printf
[E]
[D]
[R]
📄 prlimit
[E]
[D]
[R]
📄 procmail
[E]
[D]
[R]
📄 prove
[E]
[D]
[R]
📄 prtstat
[E]
[D]
[R]
📄 ps
[E]
[D]
[R]
📄 psed
[E]
[D]
[R]
📄 psfaddtable
[E]
[D]
[R]
📄 psfgettable
[E]
[D]
[R]
📄 psfstriptable
[E]
[D]
[R]
📄 psfxtable
[E]
[D]
[R]
📄 pspell-config
[E]
[D]
[R]
📄 psql
[E]
[D]
[R]
📄 pstree
[E]
[D]
[R]
📄 pstree.x11
[E]
[D]
[R]
📄 pstruct
[E]
[D]
[R]
📄 ptar
[E]
[D]
[R]
📄 ptardiff
[E]
[D]
[R]
📄 ptargrep
[E]
[D]
[R]
📄 ptaskset
[E]
[D]
[R]
📄 ptx
[E]
[D]
[R]
📄 pure-ftpwho
[E]
[D]
[R]
📄 pure-pw
[E]
[D]
[R]
📄 pure-pwconvert
[E]
[D]
[R]
📄 pure-statsdecode
[E]
[D]
[R]
📄 pwd
[E]
[D]
[R]
📄 pwdx
[E]
[D]
[R]
📄 pwmake
[E]
[D]
[R]
📄 pwscore
[E]
[D]
[R]
📄 pydoc
[E]
[D]
[R]
📄 pydoc3
[E]
[D]
[R]
📄 pydoc3.6
[E]
[D]
[R]
📄 python
[E]
[D]
[R]
📄 python2
[E]
[D]
[R]
📄 python2.7
[E]
[D]
[R]
📄 python3
[E]
[D]
[R]
📄 python3.6
[E]
[D]
[R]
📄 python3.6m
[E]
[D]
[R]
📄 pyvenv
[E]
[D]
[R]
📄 pyvenv-3.6
[E]
[D]
[R]
📄 qemu-ga
[E]
[D]
[R]
📄 quota
[E]
[D]
[R]
📄 quotasync
[E]
[D]
[R]
📄 ranlib
[E]
[D]
[R]
📄 raw
[E]
[D]
[R]
📄 razor-admin
[E]
[D]
[R]
📄 razor-check
[E]
[D]
[R]
📄 razor-client
[E]
[D]
[R]
📄 razor-report
[E]
[D]
[R]
📄 razor-revoke
[E]
[D]
[R]
📄 read
[E]
[D]
[R]
📄 readelf
[E]
[D]
[R]
📄 readlink
[E]
[D]
[R]
📄 realpath
[E]
[D]
[R]
📄 rearj
[E]
[D]
[R]
📄 recode
[E]
[D]
[R]
📄 recode-sr-latin
[E]
[D]
[R]
📄 reindexdb
[E]
[D]
[R]
📄 rename
[E]
[D]
[R]
📄 renice
[E]
[D]
[R]
📄 replace
[E]
[D]
[R]
📄 repo-graph
[E]
[D]
[R]
📄 repo-rss
[E]
[D]
[R]
📄 repoclosure
[E]
[D]
[R]
📄 repodiff
[E]
[D]
[R]
📄 repomanage
[E]
[D]
[R]
📄 repoquery
[E]
[D]
[R]
📄 reposync
[E]
[D]
[R]
📄 repotrack
[E]
[D]
[R]
📄 reset
[E]
[D]
[R]
📄 resizecons
[E]
[D]
[R]
📄 resolve_stack_dump
[E]
[D]
[R]
📄 resolveip
[E]
[D]
[R]
📄 rev
[E]
[D]
[R]
📄 rhash
[E]
[D]
[R]
📄 rm
[E]
[D]
[R]
📄 rmail
[E]
[D]
[R]
📄 rmail.postfix
[E]
[D]
[R]
📄 rmdir
[E]
[D]
[R]
📄 rnano
[E]
[D]
[R]
📄 rpcgen
[E]
[D]
[R]
📄 rpm
[E]
[D]
[R]
📄 rpm2cpio
[E]
[D]
[R]
📄 rpmdb
[E]
[D]
[R]
📄 rpmgraph
[E]
[D]
[R]
📄 rpmkeys
[E]
[D]
[R]
📄 rpmquery
[E]
[D]
[R]
📄 rpmverify
[E]
[D]
[R]
📄 rrdcached
[E]
[D]
[R]
📄 rrdcgi
[E]
[D]
[R]
📄 rrdcreate
[E]
[D]
[R]
📄 rrdinfo
[E]
[D]
[R]
📄 rrdtool
[E]
[D]
[R]
📄 rrdupdate
[E]
[D]
[R]
📄 rsync
[E]
[D]
[R]
📄 rsyslog-recover-qi.pl
[E]
[D]
[R]
📄 run-parts
[E]
[D]
[R]
📄 run-with-aspell
[E]
[D]
[R]
📄 runcon
[E]
[D]
[R]
📄 rvi
[E]
[D]
[R]
📄 rview
[E]
[D]
[R]
📄 s2p
[E]
[D]
[R]
📄 sa-awl
[E]
[D]
[R]
📄 sa-check_spamd
[E]
[D]
[R]
📄 sa-compile
[E]
[D]
[R]
📄 sa-learn
[E]
[D]
[R]
📄 sa-update
[E]
[D]
[R]
📄 sadf
[E]
[D]
[R]
📄 sandbox
[E]
[D]
[R]
📄 sar
[E]
[D]
[R]
📄 sasl2-sample-client
[E]
[D]
[R]
📄 sasl2-sample-server
[E]
[D]
[R]
📄 scp
[E]
[D]
[R]
📄 screen
[E]
[D]
[R]
📄 script
[E]
[D]
[R]
📄 scriptreplay
[E]
[D]
[R]
📄 sdiff
[E]
[D]
[R]
📄 secon
[E]
[D]
[R]
📄 sed
[E]
[D]
[R]
📄 sedismod
[E]
[D]
[R]
📄 sedispol
[E]
[D]
[R]
📄 semodule_package
[E]
[D]
[R]
📄 seq
[E]
[D]
[R]
📄 sessreg
[E]
[D]
[R]
📄 setarch
[E]
[D]
[R]
📄 setfacl
[E]
[D]
[R]
📄 setfont
[E]
[D]
[R]
📄 setkeycodes
[E]
[D]
[R]
📄 setleds
[E]
[D]
[R]
📄 setmetamode
[E]
[D]
[R]
📄 setpriv
[E]
[D]
[R]
📄 setsid
[E]
[D]
[R]
📄 setterm
[E]
[D]
[R]
📄 setup-nsssysinit
[E]
[D]
[R]
📄 setup-nsssysinit.sh
[E]
[D]
[R]
📄 setvtrgb
[E]
[D]
[R]
📄 sexp-conv
[E]
[D]
[R]
📄 sftp
[E]
[D]
[R]
📄 sfv-hash
[E]
[D]
[R]
📄 sg
[E]
[D]
[R]
📄 sh
[E]
[D]
[R]
📄 sha1sum
[E]
[D]
[R]
📄 sha224sum
[E]
[D]
[R]
📄 sha256sum
[E]
[D]
[R]
📄 sha384sum
[E]
[D]
[R]
📄 sha512sum
[E]
[D]
[R]
📄 shasum
[E]
[D]
[R]
📄 show-changed-rco
[E]
[D]
[R]
📄 show-installed
[E]
[D]
[R]
📄 showconsolefont
[E]
[D]
[R]
📄 showkey
[E]
[D]
[R]
📄 showrgb
[E]
[D]
[R]
📄 shred
[E]
[D]
[R]
📄 shuf
[E]
[D]
[R]
📄 sieve-dump
[E]
[D]
[R]
📄 sieve-filter
[E]
[D]
[R]
📄 sieve-test
[E]
[D]
[R]
📄 sievec
[E]
[D]
[R]
📄 signver
[E]
[D]
[R]
📄 sigtool
[E]
[D]
[R]
📄 sim_client
[E]
[D]
[R]
📄 size
[E]
[D]
[R]
📄 skill
[E]
[D]
[R]
📄 slabinfo
[E]
[D]
[R]
📄 slabtop
[E]
[D]
[R]
📄 sleep
[E]
[D]
[R]
📄 slogin
[E]
[D]
[R]
📄 snice
[E]
[D]
[R]
📄 snmpconf
[E]
[D]
[R]
📄 soelim
[E]
[D]
[R]
📄 sort
[E]
[D]
[R]
📄 sotruss
[E]
[D]
[R]
📄 spamassassin
[E]
[D]
[R]
📄 spamc
[E]
[D]
[R]
📄 spamd
[E]
[D]
[R]
📄 spell
[E]
[D]
[R]
📄 splain
[E]
[D]
[R]
📄 split
[E]
[D]
[R]
📄 sprof
[E]
[D]
[R]
📄 sqlite3
[E]
[D]
[R]
📄 ssh
[E]
[D]
[R]
📄 ssh-add
[E]
[D]
[R]
📄 ssh-agent
[E]
[D]
[R]
📄 ssh-copy-id
[E]
[D]
[R]
📄 ssh-keygen
[E]
[D]
[R]
📄 ssh-keyscan
[E]
[D]
[R]
📄 ssltap
[E]
[D]
[R]
📄 stat
[E]
[D]
[R]
📄 statist
[E]
[D]
[R]
📄 stdbuf
[E]
[D]
[R]
📄 stream
[E]
[D]
[R]
📄 strings
[E]
[D]
[R]
📄 strip
[E]
[D]
[R]
📄 stty
[E]
[D]
[R]
📄 su
[E]
[D]
[R]
📄 sudo
[E]
[D]
[R]
📄 sudoedit
[E]
[D]
[R]
📄 sudoreplay
[E]
[D]
[R]
📄 sum
[E]
[D]
[R]
📄 svn
[E]
[D]
[R]
📄 svnadmin
[E]
[D]
[R]
📄 svndumpfilter
[E]
[D]
[R]
📄 svnlook
[E]
[D]
[R]
📄 svnrdump
[E]
[D]
[R]
📄 svnserve
[E]
[D]
[R]
📄 svnsync
[E]
[D]
[R]
📄 svnversion
[E]
[D]
[R]
📄 sxpm
[E]
[D]
[R]
📄 sync
[E]
[D]
[R]
📄 systemctl
[E]
[D]
[R]
📄 systemd-analyze
[E]
[D]
[R]
📄 systemd-ask-password
[E]
[D]
[R]
📄 systemd-cat
[E]
[D]
[R]
📄 systemd-cgls
[E]
[D]
[R]
📄 systemd-cgtop
[E]
[D]
[R]
📄 systemd-coredumpctl
[E]
[D]
[R]
📄 systemd-delta
[E]
[D]
[R]
📄 systemd-detect-virt
[E]
[D]
[R]
📄 systemd-escape
[E]
[D]
[R]
📄 systemd-firstboot
[E]
[D]
[R]
📄 systemd-hwdb
[E]
[D]
[R]
📄 systemd-inhibit
[E]
[D]
[R]
📄 systemd-loginctl
[E]
[D]
[R]
📄 systemd-machine-id-setup
[E]
[D]
[R]
📄 systemd-notify
[E]
[D]
[R]
📄 systemd-nspawn
[E]
[D]
[R]
📄 systemd-path
[E]
[D]
[R]
📄 systemd-run
[E]
[D]
[R]
📄 systemd-stdio-bridge
[E]
[D]
[R]
📄 systemd-sysv-convert
[E]
[D]
[R]
📄 systemd-tmpfiles
[E]
[D]
[R]
📄 systemd-tty-ask-password-agent
[E]
[D]
[R]
📄 tabs
[E]
[D]
[R]
📄 tac
[E]
[D]
[R]
📄 tail
[E]
[D]
[R]
📄 tailf
[E]
[D]
[R]
📄 tapestat
[E]
[D]
[R]
📄 tar
[E]
[D]
[R]
📄 taskset
[E]
[D]
[R]
📄 tbl
[E]
[D]
[R]
📄 tcamgr
[E]
[D]
[R]
📄 tcamttest
[E]
[D]
[R]
📄 tcatest
[E]
[D]
[R]
📄 tcbmgr
[E]
[D]
[R]
📄 tcbmttest
[E]
[D]
[R]
📄 tcbtest
[E]
[D]
[R]
📄 tcfmgr
[E]
[D]
[R]
📄 tcfmttest
[E]
[D]
[R]
📄 tcftest
[E]
[D]
[R]
📄 tchmgr
[E]
[D]
[R]
📄 tchmttest
[E]
[D]
[R]
📄 tchtest
[E]
[D]
[R]
📄 tctmgr
[E]
[D]
[R]
📄 tctmttest
[E]
[D]
[R]
📄 tcttest
[E]
[D]
[R]
📄 tcucodec
[E]
[D]
[R]
📄 tcumttest
[E]
[D]
[R]
📄 tcutest
[E]
[D]
[R]
📄 teamd
[E]
[D]
[R]
📄 teamdctl
[E]
[D]
[R]
📄 teamnl
[E]
[D]
[R]
📄 tee
[E]
[D]
[R]
📄 test
[E]
[D]
[R]
📄 testgdbm
[E]
[D]
[R]
📄 tic
[E]
[D]
[R]
📄 tiger-hash
[E]
[D]
[R]
📄 timedatectl
[E]
[D]
[R]
📄 timeout
[E]
[D]
[R]
📄 tload
[E]
[D]
[R]
📄 tmon
[E]
[D]
[R]
📄 tmpwatch
[E]
[D]
[R]
📄 toe
[E]
[D]
[R]
📄 tokuft_logprint
[E]
[D]
[R]
📄 tokuftdump
[E]
[D]
[R]
📄 top
[E]
[D]
[R]
📄 touch
[E]
[D]
[R]
📄 tput
[E]
[D]
[R]
📄 tr
[E]
[D]
[R]
📄 tracepath
[E]
[D]
[R]
📄 tracepath6
[E]
[D]
[R]
📄 troff
[E]
[D]
[R]
📄 true
[E]
[D]
[R]
📄 truncate
[E]
[D]
[R]
📄 trust
[E]
[D]
[R]
📄 tset
[E]
[D]
[R]
📄 tsort
[E]
[D]
[R]
📄 tth-hash
[E]
[D]
[R]
📄 tty
[E]
[D]
[R]
📄 turbostat
[E]
[D]
[R]
📄 tzselect
[E]
[D]
[R]
📄 uconv
[E]
[D]
[R]
📄 ucs2any
[E]
[D]
[R]
📄 udevadm
[E]
[D]
[R]
📄 ul
[E]
[D]
[R]
📄 umask
[E]
[D]
[R]
📄 umount
[E]
[D]
[R]
📄 unalias
[E]
[D]
[R]
📄 uname
[E]
[D]
[R]
📄 unarj
[E]
[D]
[R]
📄 unexpand
[E]
[D]
[R]
📄 unfreeze
[E]
[D]
[R]
📄 unicode_start
[E]
[D]
[R]
📄 unicode_stop
[E]
[D]
[R]
📄 uniq
[E]
[D]
[R]
📄 unlink
[E]
[D]
[R]
📄 unlz4
[E]
[D]
[R]
📄 unshare
[E]
[D]
[R]
📄 unxz
[E]
[D]
[R]
📄 unzip
[E]
[D]
[R]
📄 unzipsfx
[E]
[D]
[R]
📄 unzoo
[E]
[D]
[R]
📄 update-ca-trust
[E]
[D]
[R]
📄 update-mime-database
[E]
[D]
[R]
📄 updatedb
[E]
[D]
[R]
📄 uptime
[E]
[D]
[R]
📄 urlgrabber
[E]
[D]
[R]
📄 users
[E]
[D]
[R]
📄 usleep
[E]
[D]
[R]
📄 utmpdump
[E]
[D]
[R]
📄 uuclient
[E]
[D]
[R]
📄 uuidgen
[E]
[D]
[R]
📄 vacuumdb
[E]
[D]
[R]
📄 vdir
[E]
[D]
[R]
📄 verifytree
[E]
[D]
[R]
📄 vi
[E]
[D]
[R]
📄 view
[E]
[D]
[R]
📄 vlock
[E]
[D]
[R]
📄 vmstat
[E]
[D]
[R]
📄 w
[E]
[D]
[R]
📄 wait
[E]
[D]
[R]
📄 wall
[E]
[D]
[R]
📄 watch
[E]
[D]
[R]
📄 watchgnupg
[E]
[D]
[R]
📄 wc
[E]
[D]
[R]
📄 wdctl
[E]
[D]
[R]
📄 wget
[E]
[D]
[R]
📄 whatis
[E]
[D]
[R]
📄 whereis
[E]
[D]
[R]
📄 which
[E]
[D]
[R]
📄 whiptail
[E]
[D]
[R]
📄 whirlpool-hash
[E]
[D]
[R]
📄 who
[E]
[D]
[R]
📄 whoami
[E]
[D]
[R]
📄 word-list-compress
[E]
[D]
[R]
📄 write
[E]
[D]
[R]
📄 wsrep_sst_common
[E]
[D]
[R]
📄 wsrep_sst_mariabackup
[E]
[D]
[R]
📄 wsrep_sst_mysqldump
[E]
[D]
[R]
📄 wsrep_sst_rsync
[E]
[D]
[R]
📄 wsrep_sst_rsync_wan
[E]
[D]
[R]
📄 wsrep_sst_xtrabackup
[E]
[D]
[R]
📄 wsrep_sst_xtrabackup-v2
[E]
[D]
[R]
📄 x86_64
[E]
[D]
[R]
📄 x86_64-redhat-linux-c++
[E]
[D]
[R]
📄 x86_64-redhat-linux-g++
[E]
[D]
[R]
📄 x86_64-redhat-linux-gcc
[E]
[D]
[R]
📄 x86_energy_perf_policy
[E]
[D]
[R]
📄 xargs
[E]
[D]
[R]
📄 xgamma
[E]
[D]
[R]
📄 xgettext
[E]
[D]
[R]
📄 xhost
[E]
[D]
[R]
📄 xinput
[E]
[D]
[R]
📄 xkill
[E]
[D]
[R]
📄 xml2-config
[E]
[D]
[R]
📄 xmlcatalog
[E]
[D]
[R]
📄 xmllint
[E]
[D]
[R]
📄 xmlwf
[E]
[D]
[R]
📄 xmodmap
[E]
[D]
[R]
📄 xorg-x11-fonts-update-dirs
[E]
[D]
[R]
📄 xrandr
[E]
[D]
[R]
📄 xrdb
[E]
[D]
[R]
📄 xrefresh
[E]
[D]
[R]
📄 xset
[E]
[D]
[R]
📄 xsetmode
[E]
[D]
[R]
📄 xsetpointer
[E]
[D]
[R]
📄 xsetroot
[E]
[D]
[R]
📄 xslt-config
[E]
[D]
[R]
📄 xsltproc
[E]
[D]
[R]
📄 xstdcmap
[E]
[D]
[R]
📄 xsubpp
[E]
[D]
[R]
📄 xz
[E]
[D]
[R]
📄 xzcat
[E]
[D]
[R]
📄 xzcmp
[E]
[D]
[R]
📄 xzdec
[E]
[D]
[R]
📄 xzdiff
[E]
[D]
[R]
📄 xzegrep
[E]
[D]
[R]
📄 xzfgrep
[E]
[D]
[R]
📄 xzgrep
[E]
[D]
[R]
📄 xzless
[E]
[D]
[R]
📄 xzmore
[E]
[D]
[R]
📄 yes
[E]
[D]
[R]
📄 ypdomainname
[E]
[D]
[R]
📄 yum
[E]
[D]
[R]
📄 yum-builddep
[E]
[D]
[R]
📄 yum-config-manager
[E]
[D]
[R]
📄 yum-debug-dump
[E]
[D]
[R]
📄 yum-debug-restore
[E]
[D]
[R]
📄 yum-groups-manager
[E]
[D]
[R]
📄 yumdownloader
[E]
[D]
[R]
📄 zcat
[E]
[D]
[R]
📄 zcmp
[E]
[D]
[R]
📄 zdiff
[E]
[D]
[R]
📄 zegrep
[E]
[D]
[R]
📄 zfgrep
[E]
[D]
[R]
📄 zforce
[E]
[D]
[R]
📄 zgrep
[E]
[D]
[R]
📄 zip
[E]
[D]
[R]
📄 zipcloak
[E]
[D]
[R]
📄 zipdetails
[E]
[D]
[R]
📄 zipgrep
[E]
[D]
[R]
📄 zipinfo
[E]
[D]
[R]
📄 zipnote
[E]
[D]
[R]
📄 zipsplit
[E]
[D]
[R]
📄 zless
[E]
[D]
[R]
📄 zmore
[E]
[D]
[R]
📄 znew
[E]
[D]
[R]
📄 zsoelim
[E]
[D]
[R]
Editing: growpart
#!/bin/sh # Copyright (C) 2011 Canonical Ltd. # Copyright (C) 2013 Hewlett-Packard Development Company, L.P. # # Authors: Scott Moser <smoser@canonical.com> # Juerg Haefliger <juerg.haefliger@hp.com> # # This program is free software: you can redistribute it and/or modify # it under the terms of the GNU General Public License as published by # the Free Software Foundation, version 3 of the License. # # This program is distributed in the hope that it will be useful, # but WITHOUT ANY WARRANTY; without even the implied warranty of # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the # GNU General Public License for more details. # # You should have received a copy of the GNU General Public License # along with this program. If not, see <http://www.gnu.org/licenses/>. # the fudge factor. if within this many bytes dont bother FUDGE=${GROWPART_FUDGE:-$((1024*1024))} TEMP_D="" RESTORE_FUNC="" RESTORE_HUMAN="" VERBOSITY=0 DISK="" PART="" PT_UPDATE=false DRY_RUN=0 SFDISK_VERSION="" SFDISK_2_26="22600" SFDISK_V_WORKING_GPT="22603" MBR_BACKUP="" GPT_BACKUP="" _capture="" error() { echo "$@" 1>&2 } fail() { [ $# -eq 0 ] || echo "FAILED:" "$@" exit 2 } nochange() { echo "NOCHANGE:" "$@" exit 1 } changed() { echo "CHANGED:" "$@" exit 0 } change() { echo "CHANGE:" "$@" exit 0 } cleanup() { if [ -n "${RESTORE_FUNC}" ]; then error "***** WARNING: Resize failed, attempting to revert ******" if ${RESTORE_FUNC} ; then error "***** Appears to have gone OK ****" else error "***** FAILED! ******" if [ -n "${RESTORE_HUMAN}" -a -f "${RESTORE_HUMAN}" ]; then error "**** original table looked like: ****" cat "${RESTORE_HUMAN}" 1>&2 else error "We seem to have not saved the partition table!" fi fi fi [ -z "${TEMP_D}" -o ! -d "${TEMP_D}" ] || rm -Rf "${TEMP_D}" } debug() { local level=${1} shift [ "${level}" -gt "${VERBOSITY}" ] && return if [ "${DEBUG_LOG}" ]; then echo "$@" >>"${DEBUG_LOG}" else error "$@" fi } debugcat() { local level="$1" shift; [ "${level}" -gt "$VERBOSITY" ] && return if [ "${DEBUG_LOG}" ]; then cat "$@" >>"${DEBUG_LOG}" else cat "$@" 1>&2 fi } mktemp_d() { # just a mktemp -d that doens't need mktemp if its not there. _RET=$(mktemp -d "${TMPDIR:-/tmp}/${0##*/}.XXXXXX" 2>/dev/null) && return _RET=$(umask 077 && t="${TMPDIR:-/tmp}/${0##*/}.$$" && mkdir "${t}" && echo "${t}") return } Usage() { cat <<EOF ${0##*/} disk partition rewrite partition table so that partition takes up all the space it can options: -h | --help print Usage and exit --fudge F if part could be resized, but change would be less than 'F' bytes, do not resize (default: ${FUDGE}) -N | --dry-run only report what would be done, show new 'sfdisk -d' -v | --verbose increase verbosity / debug -u | --update R update the the kernel partition table info after growing this requires kernel support and 'partx --update' R is one of: - 'auto' : [default] update partition if possible - 'force' : try despite sanity checks (fail on failure) - 'off' : do not attempt - 'on' : fail if sanity checks indicate no support Example: - ${0##*/} /dev/sda 1 Resize partition 1 on /dev/sda EOF } bad_Usage() { Usage 1>&2 error "$@" exit 2 } sfdisk_restore_legacy() { sfdisk --no-reread "${DISK}" -I "${MBR_BACKUP}" } sfdisk_restore() { # files are named: sfdisk-<device>-<offset>.bak local f="" offset="" fails=0 for f in "${MBR_BACKUP}"*.bak; do [ -f "$f" ] || continue offset=${f##*-} offset=${offset%.bak} [ "$offset" = "$f" ] && { error "WARN: confused by file $f"; continue; } dd "if=$f" "of=${DISK}" seek=$(($offset)) bs=1 conv=notrunc || { error "WARN: failed restore from $f"; fails=$(($fails+1)); } done return $fails } sfdisk_worked_but_blkrrpart_failed() { local ret="$1" output="$2" # exit code found was just 1, but dont insist on that #[ $ret -eq 1 ] || return 1 # Successfully wrote the new partition table grep -qi "Success.* wrote.* new.* partition" "$output" && grep -qi "BLKRRPART: Device or resource busy" "$output" return } get_sfdisk_version() { # set SFDISK_VERSION to MAJOR*10000+MINOR*100+MICRO local out oifs="$IFS" ver="" [ -n "$SFDISK_VERSION" ] && return 0 # expected output: sfdisk from util-linux 2.25.2 out=$(sfdisk --version) || { error "failed to get sfdisk version"; return 1; } set -- $out ver=$4 case "$ver" in [0-9]*.[0-9]*.[0-9]|[0-9].[0-9]*) IFS="."; set -- $ver; IFS="$oifs" SFDISK_VERSION=$(($1*10000+$2*100+${3:-0})) return 0;; *) error "unexpected output in sfdisk --version [$out]" return 1;; esac } resize_sfdisk() { local humanpt="${TEMP_D}/recovery" local mbr_backup="${TEMP_D}/orig.save" local restore_func="" local format="$1" local change_out=${TEMP_D}/change.out local dump_out=${TEMP_D}/dump.out local new_out=${TEMP_D}/new.out local dump_mod=${TEMP_D}/dump.mod local tmp="${TEMP_D}/tmp.out" local err="${TEMP_D}/err.out" local mbr_max_512="4294967296" local pt_start pt_size pt_end max_end new_size change_info dpart local sector_num sector_size disk_size tot out rqe sfd_list sfdisk --list --unit=S "$DISK" >"$tmp" || fail "failed: sfdisk --list $DISK" if [ "${SFDISK_VERSION}" -lt ${SFDISK_2_26} ]; then # exected output contains: Units: sectors of 512 bytes, ... out=$(awk '$1 == "Units:" && $5 ~ /bytes/ { print $4 }' "$tmp") || fail "failed to read sfdisk output" if [ -z "$out" ]; then error "WARN: sector size not found in sfdisk output, assuming 512" sector_size=512 else sector_size="$out" fi local _w _cyl _w1 _heads _w2 sectors _w3 t s # show-size is in units of 1024 bytes (same as /proc/partitions) t=$(sfdisk --show-size "${DISK}") || fail "failed: sfdisk --show-size $DISK" disk_size=$((t*1024)) sector_num=$(($disk_size/$sector_size)) msg="disk size '$disk_size' not evenly div by sector size '$sector_size'" [ "$((${disk_size}%${sector_size}))" -eq 0 ] || error "WARN: $msg" restore_func=sfdisk_restore_legacy else # --list first line output: # Disk /dev/vda: 20 GiB, 21474836480 bytes, 41943040 sectors local _x read _x _x _x _x disk_size _x sector_num _x < "$tmp" sector_size=$((disk_size/$sector_num)) restore_func=sfdisk_restore fi debug 1 "$sector_num sectors of $sector_size. total size=${disk_size} bytes" [ $(($disk_size/512)) -gt $mbr_max_512 ] && debug 1 "WARN: disk is larger than 2TB. additional space will go unused." rqe sfd_dump sfdisk --unit=S --dump "${DISK}" >"${dump_out}" || fail "failed to dump sfdisk info for ${DISK}" RESTORE_HUMAN="$dump_out" { echo "## sfdisk --unit=S --dump ${DISK}" cat "${dump_out}" } >"$humanpt" [ $? -eq 0 ] || fail "failed to save sfdisk -d output" RESTORE_HUMAN="$humanpt" debugcat 1 "$humanpt" sed -e 's/,//g; s/start=/start /; s/size=/size /' "${dump_out}" \ >"${dump_mod}" || fail "sed failed on dump output" dpart="${DISK}${PART}" # disk and partition number if [ -b "${DISK}p${PART}" -a "${DISK%[0-9]}" != "${DISK}" ]; then # for block devices that end in a number (/dev/nbd0) # the partition is "<name>p<partition_number>" (/dev/nbd0p1) dpart="${DISK}p${PART}" elif [ "${DISK#/dev/loop[0-9]}" != "${DISK}" ]; then # for /dev/loop devices, sfdisk output will be <name>p<number> # format also, even though there is not a device there. dpart="${DISK}p${PART}" fi pt_start=$(awk '$1 == pt { print $4 }' "pt=${dpart}" <"${dump_mod}") && pt_size=$(awk '$1 == pt { print $6 }' "pt=${dpart}" <"${dump_mod}") && [ -n "${pt_start}" -a -n "${pt_size}" ] && pt_end=$((${pt_size}+${pt_start})) || fail "failed to get start and end for ${dpart} in ${DISK}" # find the minimal starting location that is >= pt_end max_end=$(awk '$3 == "start" { if($4 >= pt_end && $4 < min) { min = $4 } } END { printf("%s\n",min); }' \ min=${sector_num} pt_end=${pt_end} "${dump_mod}") && [ -n "${max_end}" ] || fail "failed to get max_end for partition ${PART}" mbr_max_sectors=$((mbr_max_512*$((sector_size/512)))) if [ "$max_end" -gt "$mbr_max_sectors" ]; then max_end=$mbr_max_sectors fi if [ "$format" = "gpt" ]; then # sfdisk respects 'last-lba' in input, and complains about # partitions that go past that. without it, it does the right thing. sed -i '/^last-lba:/d' "$dump_out" || fail "failed to remove last-lba from output" fi local gpt_second_size="33" if [ "${max_end}" -gt "$((${sector_num}-${gpt_second_size}))" ]; then # if mbr allow subsequent conversion to gpt without shrinking the # partition. safety net at cost of 33 sectors, seems reasonable. # if gpt, we can't write there anyway. debug 1 "padding ${gpt_second_size} sectors for gpt secondary header" max_end=$((${sector_num}-${gpt_second_size})) fi debug 1 "max_end=${max_end} tot=${sector_num} pt_end=${pt_end}" \ "pt_start=${pt_start} pt_size=${pt_size}" [ $((${pt_end})) -eq ${max_end} ] && nochange "partition ${PART} is size ${pt_size}. it cannot be grown" [ $((${pt_end}+(${FUDGE}/$sector_size))) -gt ${max_end} ] && nochange "partition ${PART} could only be grown by" \ "$((${max_end}-${pt_end})) [fudge=$((${FUDGE}/$sector_size))]" # now, change the size for this partition in ${dump_out} to be the # new size new_size=$((${max_end}-${pt_start})) sed "\|^\s*${dpart} |s/\(.*\)${pt_size},/\1${new_size},/" "${dump_out}" \ >"${new_out}" || fail "failed to change size in output" change_info="partition=${PART} start=${pt_start}" change_info="${change_info} old: size=${pt_size} end=${pt_end}" change_info="${change_info} new: size=${new_size} end=${max_end}" if [ ${DRY_RUN} -ne 0 ]; then echo "CHANGE: ${change_info}" { echo "# === old sfdisk -d ===" cat "${dump_out}" echo "# === new sfdisk -d ===" cat "${new_out}" } 1>&2 exit 0 fi MBR_BACKUP="${mbr_backup}" LANG=C sfdisk --no-reread "${DISK}" --force \ -O "${mbr_backup}" <"${new_out}" >"${change_out}" 2>&1 ret=$? [ $ret -eq 0 ] || RESTORE_FUNC="${restore_func}" if [ $ret -eq 0 ]; then : elif $PT_UPDATE && sfdisk_worked_but_blkrrpart_failed "$ret" "${change_out}"; then # if the command failed, but it looks like only because # the device was busy and we have pt_update, then go on debug 1 "sfdisk failed, but likely only because of blkrrpart" else error "attempt to resize ${DISK} failed. sfdisk output below:" sed 's,^,| ,' "${change_out}" 1>&2 fail "failed to resize" fi rq pt_update pt_update "$DISK" "$PART" || fail "pt_resize failed" RESTORE_FUNC="" changed "${change_info}" # dump_out looks something like: ## partition table of /tmp/out.img #unit: sectors # #/tmp/out.img1 : start= 1, size= 48194, Id=83 #/tmp/out.img2 : start= 48195, size= 963900, Id=83 #/tmp/out.img3 : start= 1012095, size= 305235, Id=82 #/tmp/out.img4 : start= 1317330, size= 771120, Id= 5 #/tmp/out.img5 : start= 1317331, size= 642599, Id=83 #/tmp/out.img6 : start= 1959931, size= 48194, Id=83 #/tmp/out.img7 : start= 2008126, size= 80324, Id=83 } gpt_restore() { sgdisk -l "${GPT_BACKUP}" "${DISK}" } resize_sgdisk() { GPT_BACKUP="${TEMP_D}/pt.backup" local pt_info="${TEMP_D}/pt.info" local pt_pretend="${TEMP_D}/pt.pretend" local pt_data="${TEMP_D}/pt.data" local out="${TEMP_D}/out" local dev="disk=${DISK} partition=${PART}" local pt_start pt_end pt_size last pt_max code guid name new_size local old new change_info sector_size # Dump the original partition information and details to disk. This is # used in case something goes wrong and human interaction is required # to revert any changes. rqe sgd_info sgdisk "--info=${PART}" --print "${DISK}" >"${pt_info}" || fail "${dev}: failed to dump original sgdisk info" RESTORE_HUMAN="${pt_info}" sector_size=$(awk '$0 ~ /^Logical sector size:.*bytes/ { print $4 }' \ "$pt_info") && [ -n "$sector_size" ] || { sector_size=512 error "WARN: did not find sector size, assuming 512" } debug 1 "$dev: original sgdisk info:" debugcat 1 "${pt_info}" # Pretend to move the backup GPT header to the end of the disk and dump # the resulting partition information. We use this info to determine if # we have to resize the partition. rqe sgd_pretend sgdisk --pretend --move-second-header \ --print "${DISK}" >"${pt_pretend}" || fail "${dev}: failed to dump pretend sgdisk info" debug 1 "$dev: pretend sgdisk info" debugcat 1 "${pt_pretend}" # Extract the partition data from the pretend dump awk 'found { print } ; $1 == "Number" { found = 1 }' \ "${pt_pretend}" >"${pt_data}" || fail "${dev}: failed to parse pretend sgdisk info" # Get the start and end sectors of the partition to be grown pt_start=$(awk '$1 == '"${PART}"' { print $2 }' "${pt_data}") && [ -n "${pt_start}" ] || fail "${dev}: failed to get start sector" pt_end=$(awk '$1 == '"${PART}"' { print $3 }' "${pt_data}") && [ -n "${pt_end}" ] || fail "${dev}: failed to get end sector" # sgdisk start and end are inclusive. start 2048 length 10 ends at 2057. pt_end=$((pt_end+1)) pt_size="$((${pt_end} - ${pt_start}))" # Get the last usable sector last=$(awk '/last usable sector is/ { print $NF }' \ "${pt_pretend}") && [ -n "${last}" ] || fail "${dev}: failed to get last usable sector" # Find the minimal start sector that is >= pt_end pt_max=$(awk '{ if ($2 >= pt_end && $2 < min) { min = $2 } } END \ { print min }' min="${last}" pt_end="${pt_end}" \ "${pt_data}") && [ -n "${pt_max}" ] || fail "${dev}: failed to find max end sector" debug 1 "${dev}: pt_start=${pt_start} pt_end=${pt_end}" \ "pt_size=${pt_size} pt_max=${pt_max} last=${last}" # Check if the partition can be grown [ "${pt_end}" -eq "${pt_max}" ] && nochange "${dev}: size=${pt_size}, it cannot be grown" [ "$((${pt_end} + ${FUDGE}/${sector_size}))" -gt "${pt_max}" ] && nochange "${dev}: could only be grown by" \ "$((${pt_max} - ${pt_end})) [fudge=$((${FUDGE}/$sector_size))]" # The partition can be grown if we made it here. Get some more info # about it so we can do it properly. # FIXME: Do we care about the attribute flags? code=$(awk '/^Partition GUID code:/ { print $4 }' "${pt_info}") guid=$(awk '/^Partition unique GUID:/ { print $4 }' "${pt_info}") name=$(awk '/^Partition name:/ { gsub(/'"'"'/, "") ; \ if (NF >= 3) print substr($0, index($0, $3)) }' "${pt_info}") [ -n "${code}" -a -n "${guid}" ] || fail "${dev}: failed to parse sgdisk details" debug 1 "${dev}: code=${code} guid=${guid} name='${name}'" local wouldrun="" [ "$DRY_RUN" -ne 0 ] && wouldrun="would-run" # Calculate the new size of the partition new_size=$((${pt_max} - ${pt_start})) change_info="partition=${PART} start=${pt_start}" change_info="${change_info} old: size=${pt_size} end=${pt_end}" change_info="${change_info} new: size=${new_size} end=${pt_max}" # Backup the current partition table, we're about to modify it rq sgd_backup $wouldrun sgdisk "--backup=${GPT_BACKUP}" "${DISK}" || fail "${dev}: failed to backup the partition table" # Modify the partition table. We do it all in one go (the order is # important!): # - move the GPT backup header to the end of the disk # - delete the partition # - recreate the partition with the new size # - set the partition code # - set the partition GUID # - set the partition name rq sgdisk_mod $wouldrun sgdisk --move-second-header "--delete=${PART}" \ "--new=${PART}:${pt_start}:$((pt_max-1))" \ "--typecode=${PART}:${code}" \ "--partition-guid=${PART}:${guid}" \ "--change-name=${PART}:${name}" "${DISK}" && rq pt_update $wouldrun pt_update "$DISK" "$PART" || { RESTORE_FUNC=gpt_restore fail "${dev}: failed to repartition" } # Dry run [ "${DRY_RUN}" -ne 0 ] && change "${change_info}" changed "${change_info}" } kver_to_num() { local kver="$1" maj="" min="" mic="0" kver=${kver%%-*} maj=${kver%%.*} min=${kver#${maj}.} min=${min%%.*} mic=${kver#${maj}.${min}.} [ "$kver" = "$mic" ] && mic=0 _RET=$(($maj*1000*1000+$min*1000+$mic)) } kver_cmp() { local op="$2" n1="" n2="" kver_to_num "$1" n1="$_RET" kver_to_num "$3" n2="$_RET" [ $n1 $op $n2 ] } rq() { # runquieterror(label, command) # gobble stderr of a command unless it errors local label="$1" ret="" efile="" efile="$TEMP_D/$label.err" shift; local rlabel="running" [ "$1" = "would-run" ] && rlabel="would-run" && shift local cmd="" x="" for x in "$@"; do [ "${x#* }" != "$x" -o "${x#* \"}" != "$x" ] && x="'$x'" cmd="$cmd $x" done cmd=${cmd# } debug 2 "$rlabel[$label][$_capture]" "$cmd" [ "$rlabel" = "would-run" ] && return 0 if [ "${_capture}" = "erronly" ]; then "$@" 2>"$TEMP_D/$label.err" ret=$? else "$@" >"$TEMP_D/$label.err" 2>&1 ret=$? fi if [ $ret -ne 0 ]; then error "failed [$label:$ret]" "$@" cat "$efile" 1>&2 fi return $ret } rqe() { local _capture="erronly" rq "$@" } verify_ptupdate() { local input="$1" found="" reason="" kver="" # we can always satisfy 'off' if [ "$input" = "off" ]; then _RET="false"; return 0; fi if command -v partx >/dev/null 2>&1; then local out="" ret=0 out=$(partx --help 2>&1) ret=$? if [ $ret -eq 0 ]; then echo "$out" | grep -q -- --update || { reason="partx has no '--update' flag in usage." found="off" } else reason="'partx --help' returned $ret. assuming it is old." found="off" fi else reason="no 'partx' command" found="off" fi if [ -z "$found" ]; then if [ "$(uname)" != "Linux" ]; then reason="Kernel is not Linux per uname." found="off" fi fi if [ -z "$found" ]; then kver=$(uname -r) || debug 1 "uname -r failed!" if ! kver_cmp "${kver-0.0.0}" -ge 3.8.0; then reason="Kernel '$kver' < 3.8.0." found="off" fi fi if [ -z "$found" ]; then _RET="true" return 0 fi case "$input" in on) error "$reason"; return 1;; auto) _RET="false"; debug 1 "partition update disabled: $reason" return 0;; force) _RET="true" error "WARNING: ptupdate forced on even though: $reason" return 0;; esac error "unknown input '$input'"; return 1; } pt_update() { local dev="$1" part="$2" update="${3:-$PT_UPDATE}" if ! $update; then return 0 fi # partx only works on block devices (do not run on file) [ -b "$dev" ] || return 0 partx --update --nr "$part" "$dev" } has_cmd() { command -v "${1}" >/dev/null 2>&1 } resize_sgdisk_gpt() { resize_sgdisk gpt } resize_sgdisk_dos() { fail "unable to resize dos label with sgdisk" } resize_sfdisk_gpt() { resize_sfdisk gpt } resize_sfdisk_dos() { resize_sfdisk dos } get_table_format() { local out="" disk="$1" if has_cmd blkid && out=$(blkid -o value -s PTTYPE "$disk") && [ "$out" = "dos" -o "$out" = "gpt" ]; then _RET="$out" return fi _RET="dos" if [ ${SFDISK_VERSION} -lt ${SFDISK_2_26} ] && out=$(sfdisk --id --force "$disk" 1 2>/dev/null); then if [ "$out" = "ee" ]; then _RET="gpt" else _RET="dos" fi return elif out=$(LANG=C sfdisk --list "$disk"); then out=$(echo "$out" | sed -e '/Disklabel type/!d' -e 's/.*: //') case "$out" in gpt|dos) _RET="$out";; *) error "WARN: unknown label $out";; esac fi } get_resizer() { local format="$1" user=${2:-"auto"} case "$user" in sgdisk) _RET="resize_sgdisk_$format"; return;; sfdisk) _RET="resize_sfdisk_$format"; return;; auto) :;; *) error "unexpected input: '$user'";; esac if [ "$format" = "dos" ]; then _RET="resize_sfdisk_dos" return 0 fi if [ "${SFDISK_VERSION}" -ge ${SFDISK_V_WORKING_GPT} ]; then # sfdisk 2.26.2 works for resize but loses type (LP: #1474090) _RET="resize_sfdisk_gpt" elif has_cmd sgdisk; then _RET="resize_sgdisk_$format" else error "no tools available to resize disk with '$format'" return 1 fi return 0 } pt_update="auto" resizer=${GROWPART_RESIZER:-"auto"} while [ $# -ne 0 ]; do cur=${1} next=${2} case "$cur" in -h|--help) Usage exit 0 ;; --fudge) FUDGE=${next} shift ;; -N|--dry-run) DRY_RUN=1 ;; -u|--update|--update=*) if [ "${cur#--update=}" != "$cur" ]; then next="${cur#--update=}" else shift fi case "$next" in off|auto|force|on) pt_update=$next;; *) fail "unknown --update option: $next";; esac ;; -v|--verbose) VERBOSITY=$(($VERBOSITY+1)) ;; --) shift break ;; -*) fail "unknown option ${cur}" ;; *) if [ -z "${DISK}" ]; then DISK=${cur} else [ -z "${PART}" ] || fail "confused by arg ${cur}" PART=${cur} fi ;; esac shift done [ -n "${DISK}" ] || bad_Usage "must supply disk and partition-number" [ -n "${PART}" ] || bad_Usage "must supply partition-number" has_cmd "sfdisk" || fail "sfdisk not found" get_sfdisk_version || fail [ -e "${DISK}" ] || fail "${DISK}: does not exist" [ "${PART#*[!0-9]}" = "${PART}" ] || fail "partition-number must be a number" verify_ptupdate "$pt_update" || fail PT_UPDATE=$_RET debug 1 "update-partition set to $PT_UPDATE" mktemp_d && TEMP_D="${_RET}" || fail "failed to make temp dir" trap cleanup 0 # EXIT - some shells may not like 'EXIT' but are ok with 0 # get the ID of the first partition to determine if it's MBR or GPT get_table_format "$DISK" || fail format=$_RET get_resizer "$format" "$resizer" || fail "failed to get a resizer for id '$id'" resizer=$_RET debug 1 "resizing $PART on $DISK using $resizer" "$resizer" # vi: ts=4 noexpandtab
Save